/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License. You can obtain
 * a copy of the License at https://glassfish.dev.java.net/public/CDDL+GPL.html
 * or glassfish/bootstrap/legal/LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 * 
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at glassfish/bootstrap/legal/LICENSE.txt.
 * Sun designates this particular file as subject to the "Classpath" exception
 * as provided by Sun in the GPL Version 2 section of the License file that
 * accompanied this code.  If applicable, add the following below the License
 * Header, with the fields enclosed by brackets [] replaced by your own
 * identifying information: "Portions Copyrighted [year]
 * [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */
package org.glassfish.admin.amx.j2ee;

import com.sun.appserv.management.base.Util;
import com.sun.appserv.management.j2ee.J2EEModule;
import com.sun.appserv.management.j2ee.J2EETypes;
import com.sun.appserv.management.util.misc.GSetUtil;
import org.glassfish.admin.amx.mbean.Delegate;

import javax.management.ObjectName;
import java.util.Set;

/**
 */
public class J2EEModuleImplBase extends J2EEDeployedObjectImplBase
{
		public
	J2EEModuleImplBase(
        final String j2eeType,
        final String fullType,
        final ObjectName parentObjectName,
        final Class<? extends J2EEModule> theInterface,
        final Delegate delegate )
	{
		super( j2eeType, fullType, parentObjectName, theInterface, delegate );
	}
	
	private static final Set<String> NOT_SUPERFLUOUS =
	    GSetUtil.newUnmodifiableStringSet(
	        "getJVMObjectName"
            );
        protected Set<String>
	getNotSuperfluousMethods()
	{
	    return NOT_SUPERFLUOUS;
	}
	
	
		protected boolean
	isStandalone()
	{
		// caution--could be called when ObjectName is not yet set
		return getObjectName() != null &&
			getKeyProperty( J2EETypes.J2EE_APPLICATION ).equals( NULL_NAME );
	}
	
		public boolean
	isConfigProvider()
	{
		return( super.isConfigProvider() && getObjectName() != null && isStandalone() );
	}
	
		public String[]
	getjavaVMs()
	{
		return( getJ2EEServer().getjavaVMs() );
	}
	
		public ObjectName
	getJVMObjectName()
	{
		return Util.getObjectName( getJ2EEServer().getJVM() );
	}

	/** jsr77 StateManageable impl. */

		public boolean
	isstateManageable()
	{
		return isStandAlone();
	}

		private boolean
	isStandAlone()
	{
		return !getContainer().getJ2EEType().equals( J2EETypes.J2EE_APPLICATION );
	}
}
